package br.com.dclick.model
{
	import br.com.dclick.model.domain.AgendaModel;
	import br.com.dclick.model.presentation.MainPM;
	
	import com.adobe.cairngorm.model.IModelLocator;

	/**
	 * @author pablo.souza
	 * 
	 * O ModelLocator é seu meio de acesso aos
	 * Domain Model(s) e o PresentationModel.
	 */
	[Bindable]
	public class ModelLocator implements IModelLocator
	{
		private static var instance:ModelLocator ;

		/**
		 * Presentation Model principal
		 */
		public var mainPM:MainPM;
		
		/**
		 *  Domain Model 
		 */
		public var agendaModel:AgendaModel;

		public static function getInstance():ModelLocator
		{
			if( instance==null) 
			{
				instance = new ModelLocator();
				 
				/** 
				 * O Domain Model e o Presentation Model principal
				 * são instanciados no momento que nosso ModelLocator 
				 * também é instanciado 
				 */
				instance.agendaModel = new AgendaModel();
				instance.mainPM = new MainPM(instance.agendaModel);
			}
			return instance;
		}
	}
}