package br.com.dclick.model.presentation
{
	import flash.events.EventDispatcher;
	
	/**
	 * @author pablo.souza
	 * 
	 * Super classe dos Presentation Models
	 * 
	 * Define comportamentos comuns aos Presentation Models.
	 *
	 * A classe herda de EventDispatcher, uma vez que suas views
	 * vão observar seus Presentation Models e atualizá-los. 
	 */	

	public class AbstractPM extends EventDispatcher
	{
		
		private var firstShow:Boolean = true;
		
		public function AbstractPM()
		{
		}
		
		public function handleShow():void
		{
			if(firstShow)
			{
				handleFirstShow();
				firstShow = false;				
			} else {
				handleSubsequentShows();
			} 
		}
		
		protected function handleFirstShow():void
		{
			// to be overriden
		}
		
		protected function handleSubsequentShows():void
		{
			// to be overriden
		}
	}
}