package br.com.dclick.model.presentation
{
	import br.com.dclick.control.events.ContactEvent;
	import br.com.dclick.model.domain.AgendaModel;
	import br.com.dclick.model.domain.vo.Contact;
	
	/**
	 * 
	 * @author pablo.souza
	 * 
	 * Presentation Model para a lista de Contatos
	 * 
	 * Antenção para como o método setContact atualiza
	 * diretamente o modelo.
	 * 
	 */
	 	
	[Bindable]
	public class ContactListPM extends AbstractPM
	{
		
		public var agendaModel:AgendaModel;
		
		/**
		 * 
		 * @param pModel - Domain Model da aplicação
		 * @return 
		 * 
		 */		
		public function ContactListPM(pModel:AgendaModel)
		{
			agendaModel = pModel;
		}
		
		/**
		 * Dispara evento para preencher a lista de contatos
		 * 
		 */		
		public function getAllContacts():void
		{
			 new ContactEvent(ContactEvent.EVENT_CONTACT_GET_ALL).dispatch();
		}
		
		/**
		 * 
		 * @param pContact - Objeto ContatoVO que representa um contato
		 * 
		 */		
		public function setContact(pContact:Contact):void
		{
			agendaModel.currentContact = pContact;
		}
		
	}
}