package br.com.dclick.model.presentation
{
	import br.com.dclick.control.events.ContactEvent;
	import br.com.dclick.control.events.PersonEvent;
	import br.com.dclick.model.domain.AgendaModel;

	/**
	 * @author pablo.souza
	 * 
	 * Presentation Model relacionado com a view principal da aplicação. 
	 * 
	 * Tem a responsabilidade de instanciar os Presentation Models "filhos".
	 */
	[Bindable]
	public class MainPM extends AbstractPM
	{
		/* Domain Model */
		public var agendaModel:AgendaModel;
		/* Presentation Model */
		public var contactListPM:ContactListPM;
		/* Presentation Model */
		public var contactDetailsPM:ContactDetailsPM;
		
		/**
		 * 
		 * @param pAgendaModel - Domain Model da aplicação
		 * @return 
		 * 
		 */		
		public function MainPM(pAgendaModel:AgendaModel)
		{
			 // Recebe instância do Domain Model da aplicação
			agendaModel = pAgendaModel;
			
			 // Inicializa Presentation Models
			contactListPM = new ContactListPM(agendaModel);
			contactDetailsPM = new ContactDetailsPM(agendaModel);
		}
		
		/**
		 * 
		 * Dispara comandos para inicializar a aplicação 
		 * 
		 */		
		override protected function handleFirstShow():void
		{			
			new PersonEvent(PersonEvent.EVENT_PERSON_GET_ALL).dispatch();	
			new ContactEvent(ContactEvent.EVENT_CONTACT_GET_ALL).dispatch();
		}		
		
	}
}